// Copyright (C) 2020  Matthew "strager" Glazar
// See end of file for extended copyright information.

#ifndef QUICK_LINT_JS_TRANSLATION_TABLE_GENERATED_H
#define QUICK_LINT_JS_TRANSLATION_TABLE_GENERATED_H

// This file is **GENERATED** by tools/compile-translations.go.

#include <cstddef>
#include <cstdint>
#include <iterator>
#include <quick-lint-js/assert.h>
#include <quick-lint-js/consteval.h>
#include <quick-lint-js/hash-fnv.h>
#include <quick-lint-js/translation-table.h>
#include <string_view>

namespace quick_lint_js {
using namespace std::literals::string_view_literals;

constexpr std::uint32_t translation_table_locale_count = 4;
constexpr std::uint16_t translation_table_mapping_table_size = 258;
constexpr std::size_t translation_table_string_table_size = 48734;
constexpr std::size_t translation_table_locale_table_size = 24;

QLJS_CONSTEVAL std::uint16_t translation_table_const_hash_table_look_up(
    std::string_view untranslated) {
  struct const_hash_entry {
    std::uint16_t mapping_table_index;
    const char* untranslated;
  };

  // clang-format off
  constexpr const_hash_entry const_hash_table[] = {
          {0, ""},
          {0, ""},
          {226, "unexpected 'finally' without 'try'"},
          {87, "expected ',' between object literal entries"},
          {0, ""},
          {50, "assignment to const variable before its declaration"},
          {42, "a {{0} b }} c"},
          {29, "C-style for loops have only three semicolon-separated components"},
          {99, "expected variable name for 'import'-'as'"},
          {48, "assignment to const global variable"},
          {69, "children end here"},
          {0, ""},
          {12, "'async static' is not allowed; write 'static async' instead"},
          {175, "missing operator between expression and arrow function"},
          {239, "unexpected token in variable declaration; expected variable name"},
          {0, ""},
          {0, ""},
          {94, "expected expression before semicolon"},
          {0, ""},
          {0, ""},
          {0, ""},
          {65, "cannot import variable named keyword '{0}'"},
          {63, "cannot export variable named keyword '{0}'"},
          {253, "while loop needs parentheses around condition"},
          {98, "expected variable name for 'catch'"},
          {168, "missing initializer in const declaration"},
          {0, ""},
          {0, ""},
          {21, "'with' statement"},
          {177, "missing parentheses around left-hand side of '**'"},
          {131, "label named 'await' not allowed in async function"},
          {137, "missing ',' between variable declarations"},
          {33, "TypeScript's 'enum' feature is not yet implemented by quick-lint-js"},
          {55, "break can only be used inside of a loop or switch"},
          {141, "missing '=' after variable"},
          {0, ""},
          {159, "missing comparison; '{1}' does not extend to the right side of '{0}'"},
          {0, ""},
          {3, "\"globals\" descriptor \"shadowable\" property must be a boolean"},
          {182, "missing semicolon after statement"},
          {0, ""},
          {0, ""},
          {0, ""},
          {143, "missing 'while (condition)' for do-while statement"},
          {0, ""},
          {0, ""},
          {77, "continue can only be used inside of a loop"},
          {165, "missing for loop header"},
          {217, "unclosed regexp literal"},
          {157, "missing catch variable name between parentheses"},
          {4, "\"globals\" descriptor \"writable\" property must be a boolean"},
          {118, "hex number literal has no digits"},
          {156, "missing catch or finally clause for try statement"},
          {219, "unclosed template"},
          {218, "unclosed string literal"},
          {36, "a 'for' loop"},
          {0, ""},
          {0, ""},
          {78, "depth limit exceeded"},
          {103, "exporting requires '{{' and '}'"},
          {0, ""},
          {0, ""},
          {0, ""},
          {27, "BigInt literal contains exponent"},
          {241, "unmatched '}'"},
          {0, ""},
          {0, ""},
          {0, ""},
          {0, ""},
          {201, "remove '{0}' to update an existing variable"},
          {85, "existing variable declared here"},
          {0, ""},
          {0, ""},
          {117, "here"},
          {0, ""},
          {0, ""},
          {0, ""},
          {188, "new variable shadows existing variable"},
          {227, "unexpected '{0}'"},
          {34, "TypeScript's 'interface' feature is not allowed in JavaScript code"},
          {66, "cannot reference private variables without object; use 'this.'"},
          {124, "integer cannot be represented and will be rounded to '{1}'"},
          {192, "object literal started here"},
          {106, "for-in loop expression cannot have semicolons"},
          {184, "missing semicolon between init and condition parts of for loop"},
          {0, ""},
          {49, "assignment to const variable"},
          {0, ""},
          {135, "methods should not use the 'function' keyword"},
          {211, "try statement starts here"},
          {0, ""},
          {0, ""},
          {144, "missing arrow operator for arrow function"},
          {254, "with statement is missing '{1}' around expression"},
          {0, ""},
          {0, ""},
          {72, "code point out of range"},
          {146, "missing body for 'if' statement"},
          {0, ""},
          {154, "missing body for while loop"},
          {0, ""},
          {231, "unexpected characters in octal literal"},
          {90, "expected 'from' before module specifier"},
          {0, ""},
          {246, "use of undeclared variable: {0}"},
          {0, ""},
          {197, "private properties are not allowed in object literals"},
          {0, ""},
          {233, "unexpected expression; missing key for object entry"},
          {0, ""},
          {123, "indexing requires an expression"},
          {107, "for-of loop expression cannot have semicolons"},
          {232, "unexpected control character"},
          {80, "do-while loop needs parentheses around condition"},
          {203, "see here"},
          {244, "unopened block comment"},
          {193, "octal literal may not have decimal"},
          {0, ""},
          {0, ""},
          {160, "missing condition for if statement"},
          {0, ""},
          {83, "escaping '-' is not allowed in tag names; write '-' instead"},
          {150, "missing body for do-while loop"},
          {130, "keywords cannot contain escape sequences"},
          {138, "missing '...' in JSX attribute spread"},
          {41, "a lexical declaration is not allowed as the body of {1:singular}"},
          {243, "unmatched parenthesis"},
          {0, ""},
          {0, ""},
          {6, "\"globals\" must be an object"},
          {13, "'await' cannot be followed by an arrow function; use 'async' instead"},
          {97, "expected parameter for arrow function, but got an expression instead"},
          {43, "an 'if' statement"},
          {149, "missing body for class"},
          {8, "'.' operator needs a key name; use + to concatenate strings; use [] to access with a dynamic key"},
          {25, "'}' is not allowed directly in JSX text; write {{'}'} instead"},
          {139, "missing ':' in conditional expression"},
          {51, "assignment to imported variable"},
          {79, "do-while loop is missing '{1}' around condition"},
          {0, ""},
          {126, "invalid expression left of assignment"},
          {122, "incomplete export; expected 'export default ...' or 'export {{name}' or 'export * from ...' or 'export class' or 'export function' or 'export let'"},
          {58, "cannot declare 'await' inside async function"},
          {129, "invalid lone literal in object literal"},
          {40, "a function statement is not allowed as the body of {1:singular}"},
          {163, "missing end of array; expected ']'"},
          {105, "for loop needs an iterable, or condition and update clauses"},
          {189, "newline is not allowed between 'async' and arrow function parameter list"},
          {236, "unexpected statement before first switch case, expected 'case' or 'default'"},
          {57, "cannot assign to loop variable in for of/in loop"},
          {186, "missing variable name"},
          {0, ""},
          {194, "octal literal may not have exponent"},
          {228, "unexpected characters in binary literal"},
          {0, ""},
          {89, "expected 'from \"name_of_module.mjs\"'"},
          {11, "'?' creates a conditional expression"},
          {250, "variable used before declaration: {0}"},
          {0, ""},
          {0, ""},
          {64, "cannot import 'let'"},
          {140, "missing '<>' and '</>' to enclose multiple children"},
          {47, "assigning to 'async' in a for-of loop requires parentheses"},
          {0, ""},
          {166, "missing function parameter list"},
          {174, "missing operand for operator"},
          {0, ""},
          {0, ""},
          {161, "missing condition for switch statement"},
          {1, "\"global-groups\" entries must be strings"},
          {202, "return statement returns nothing (undefined)"},
          {53, "attribute has wrong capitalization; write '{1}' instead"},
          {0, ""},
          {179, "missing parentheses around self-invoked function"},
          {0, ""},
          {92, "expected expression after 'case'"},
          {0, ""},
          {111, "function called before declaration in block scope: {0}"},
          {73, "commas are not allowed after spread parameter"},
          {22, "'{0}' found here"},
          {81, "do-while statement starts here"},
          {104, "extra ',' is not allowed between function call arguments"},
          {0, ""},
          {0, ""},
          {204, "something happened"},
          {220, "unexpected '#'"},
          {224, "unexpected 'catch' without 'try'"},
          {0, ""},
          {0, ""},
          {170, "missing name of class"},
          {0, ""},
          {225, "unexpected 'default' outside switch statement"},
          {0, ""},
          {44, "another invalid string, do not use outside benchmark"},
          {245, "use 'while' instead to loop until a condition is false"},
          {0, ""},
          {59, "cannot declare 'yield' inside generator function"},
          {142, "missing 'if' after 'else'"},
          {240, "unicode byte order mark (BOM) cannot appear before #! at beginning of script"},
          {0, ""},
          {257, "~~~ invalid string, do not use outside benchmark ~~~"},
          {0, ""},
          {102, "exporting requires 'default'"},
          {205, "stray comma in function parameter"},
          {173, "missing name or parentheses for function"},
          {45, "array started here"},
          {221, "unexpected '@'"},
          {210, "this {1} looks fishy"},
          {0, ""},
          {247, "variable already declared here"},
          {0, ""},
          {0, ""},
          {209, "this {0} looks fishy"},
          {54, "binary number literal has no digits"},
          {119, "if statement is missing '{1}' around condition"},
          {0, ""},
          {0, ""},
          {0, ""},
          {46, "arrow is here"},
          {207, "switch statement is missing '{1}' around condition"},
          {30, "JSON syntax error"},
          {0, ""},
          {0, ""},
          {0, ""},
          {191, "number literal contains trailing underscore(s)"},
          {91, "expected '{{'"},
          {180, "missing property name after '.' operator"},
          {38, "a 'with' statement"},
          {100, "expected {1:headlinese}"},
          {56, "cannot access private identifier outside class"},
          {172, "missing name of exported function"},
          {0, ""},
          {0, ""},
          {0, ""},
          {0, ""},
          {86, "expected ')' to close function call"},
          {187, "misspelled React attribute; write '{1}' instead"},
          {125, "invalid UTF-8 sequence"},
          {0, ""},
          {35, "a 'do-while' loop"},
          {60, "cannot declare and export variable with 'export default'"},
          {67, "cannot update variable with '{0}' while declaring it"},
          {71, "code point in Unicode escape sequence must not be greater than U+10FFFF"},
          {24, "'{0}' operator cannot be used before '**' without parentheses"},
          {5, "\"globals\" descriptor must be a boolean or an object"},
          {31, "React/JSX is not yet implemented"},
          {75, "const fields within classes are only allowed in TypeScript, not JavaScript"},
          {19, "'in' disallowed in C-style for loop initializer"},
          {68, "character is not allowed in identifiers"},
          {200, "redundant delete statement on variable"},
          {235, "unexpected literal in parameter list; expected parameter name"},
          {0, ""},
          {127, "invalid function parameter"},
          {145, "missing body for 'for' loop"},
          {213, "unclosed class; expected '}' by end of file"},
          {230, "unexpected characters in number literal"},
          {234, "unexpected identifier in expression; missing operator before"},
          {164, "missing expression between parentheses"},
          {0, ""},
          {183, "missing semicolon between condition and update parts of for loop"},
          {151, "missing body for finally clause"},
          {0, ""},
          {0, ""},
          {0, ""},
          {158, "missing comma between object literal entries"},
          {26, "BigInt literal contains decimal point"},
          {134, "let statement cannot declare variables named 'let'"},
          {0, ""},
          {206, "stray comma in let statement"},
          {88, "expected 'as' between '{1}' and '{2}'"},
          {15, "'do-while' loop"},
          {0, ""},
          {222, "unexpected '\\' in identifier"},
          {255, "with statement needs parentheses around expression"},
          {17, "'for' loop"},
          {208, "switch statement needs parentheses around condition"},
          {0, ""},
          {0, ""},
          {62, "cannot export variable named 'let'"},
          {109, "free {1} and {0} {1} {2}"},
          {0, ""},
          {252, "while loop is missing '{1}' around condition"},
          {74, "commas are not allowed between class methods"},
          {0, ""},
          {0, ""},
          {37, "a 'while' loop"},
          {0, ""},
          {10, "'>' is not allowed directly in JSX text; write {{'>'} or &gt; instead"},
          {96, "expected parameter for arrow function, but got a literal instead"},
          {113, "function starts here"},
          {0, ""},
          {128, "invalid hex escape sequence: {0}"},
          {52, "assignment to undeclared variable"},
          {61, "cannot declare variable named keyword '{0}'"},
          {20, "'while' loop"},
          {0, ""},
          {133, "legacy octal literals may not contain underscores"},
          {167, "missing header and body for 'for' loop"},
          {216, "unclosed object literal; expected '}'"},
          {0, ""},
          {153, "missing body for try statement"},
          {108, "forwarding exports are only allowed in export-from"},
          {115, "generator function '*' belongs after keyword function"},
          {28, "C-style for loop is missing its third component"},
          {0, ""},
          {190, "number literal contains consecutive underscores"},
          {0, ""},
          {0, ""},
          {0, ""},
          {0, ""},
          {0, ""},
          {215, "unclosed identifier escape sequence"},
          {238, "unexpected token in export; expected 'export default ...' or 'export {{name}' or 'export * from ...' or 'export class' or 'export function' or 'export let'"},
          {0, ""},
          {0, ""},
          {84, "event attributes must be camelCase: '{1}'"},
          {251, "what is this '{1}' nonsense?"},
          {147, "missing body for 'switch' statement"},
          {214, "unclosed code block; expected '}' by end of file"},
          {0, ""},
          {212, "unclosed block comment"},
          {195, "octal number literal has no digits"},
          {120, "if statement needs parentheses around condition"},
          {0, ""},
          {0, ""},
          {101, "expected {1:singular}"},
          {23, "'{0}' is not allowed for strings; use {1} instead"},
          {256, "{0} with no bindings"},
          {116, "generator function '*' belongs before function name"},
          {162, "missing condition for while statement"},
          {7, "'**' operator cannot be used after unary '{1}' without parentheses"},
          {114, "functions/methods should not have '=>'"},
          {178, "missing parentheses around operand of '{0}'"},
          {16, "'else' has no corresponding 'if'"},
          {171, "missing name of exported class"},
          {2, "\"global-groups\" must be a boolean or an array"},
          {136, "mismatched JSX tags; expected '</{1}>'"},
          {70, "classes cannot be named 'let'"},
          {95, "expected hexadecimal digits in Unicode escape sequence"},
          {249, "variable declared here"},
          {229, "unexpected characters in hex literal"},
          {9, "'=' changes variables; to compare, use '===' instead"},
          {248, "variable assigned before its declaration"},
          {14, "'await' is only allowed in async functions"},
          {185, "missing value for object property"},
          {82, "escaped character is not allowed in identifiers"},
          {169, "missing name in function statement"},
          {237, "unexpected token"},
          {198, "redeclaration of global variable"},
          {0, ""},
          {110, "function call started here"},
          {0, ""},
          {39, "a class statement is not allowed as the body of {1:singular}"},
          {132, "legacy octal literal may not be BigInt"},
          {93, "expected expression before newline"},
          {121, "imported variable declared here"},
          {32, "RegExp literal flags cannot contain Unicode escapes"},
          {0, ""},
          {0, ""},
          {112, "function declared here"},
          {0, ""},
          {152, "missing body for function"},
          {148, "missing body for catch clause"},
          {0, ""},
          {181, "missing property name between '.' and '.'"},
          {0, ""},
          {223, "unexpected 'case' outside switch statement"},
          {0, ""},
          {76, "const variable declared here"},
          {199, "redeclaration of variable: {0}"},
          {242, "unmatched indexing bracket"},
          {0, ""},
          {0, ""},
          {155, "missing body for {1:headlinese}"},
          {0, ""},
          {0, ""},
          {0, ""},
          {0, ""},
          {196, "opening '<{1}>' tag here"},
          {0, ""},
          {0, ""},
          {176, "missing parameters for arrow function"},
          {0, ""},
          {0, ""},
          {0, ""},
          {18, "'if' statement"},
  };
  // clang-format on

  std::uint64_t hash = hash_fnv_1a_64(untranslated, 14695981039346656661ULL);
  std::uint64_t table_size = 386;
  for (std::uint64_t attempt = 0; attempt <= 4; ++attempt) {
    const const_hash_entry& hash_entry =
        const_hash_table[(hash + attempt * attempt) % table_size];
    if (hash_entry.mapping_table_index == 0) {
      break;
    }
    if (hash_entry.untranslated == untranslated) {
      return hash_entry.mapping_table_index;
    }
  }

  // If you see an error with the following line, translation-table-generated.h
  // is out of date. Run tools/update-translator-sources to rebuild this file.
  QLJS_CONSTEXPR_ASSERT(false);

  return 0;
}
}

#endif

// quick-lint-js finds bugs in JavaScript programs.
// Copyright (C) 2020  Matthew "strager" Glazar
//
// This file is part of quick-lint-js.
//
// quick-lint-js is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// quick-lint-js is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.
